package com.sample.util;

import org.drools.event.process.ProcessCompletedEvent;
import org.drools.event.process.ProcessEventListener;
import org.drools.event.process.ProcessNodeLeftEvent;
import org.drools.event.process.ProcessNodeTriggeredEvent;
import org.drools.event.process.ProcessStartedEvent;
import org.drools.event.process.ProcessVariableChangedEvent;
import org.drools.runtime.StatefulKnowledgeSession;

public class MyProcessEventListener implements ProcessEventListener {

	private StatefulKnowledgeSession ksession;
	
	public MyProcessEventListener(){
		this.ksession = null;
	}

	public MyProcessEventListener(StatefulKnowledgeSession ksession){
		this.ksession = ksession;
	}
	
	@Override
	public void afterNodeLeft(ProcessNodeLeftEvent event) {
//		System.out.println("afterNodeLeft => " + event.getNodeInstance().getNodeName());
	}

	@Override
	public void afterNodeTriggered(ProcessNodeTriggeredEvent event) {
//		System.out.println("afterNodeLeft => " + event.getNodeInstance().getNodeName());
	}

	@Override
	public void afterProcessCompleted(ProcessCompletedEvent event) {
		System.out.println("Process completed =>" + event.getProcessInstance().getProcessName());
		ksession.dispose();
		System.out.println("We have fired the command to dispose session");
	}

	@Override
	public void afterProcessStarted(ProcessStartedEvent event) {
		System.out.println("after Process started =>" + event.getProcessInstance().getProcessName());
	}

	@Override
	public void afterVariableChanged(ProcessVariableChangedEvent event) {
//		System.out.println("After Variable changed event");
	}

	@Override
	public void beforeNodeLeft(ProcessNodeLeftEvent event) {
//		System.out.println("Before Node Left => " + event.getNodeInstance().getNodeName());
	}

	@Override
	public void beforeNodeTriggered(ProcessNodeTriggeredEvent event) {
//		System.out.println("Before Node Triggerd => " + event.getNodeInstance().getNodeName());
	}

	@Override
	public void beforeProcessCompleted(ProcessCompletedEvent event) {
//		System.out.println("Before Process Completed =>" + event.getProcessInstance().getProcessName());
	}

	@Override
	public void beforeProcessStarted(ProcessStartedEvent event) {
//		System.out.println("Before Process started =>" + event.getProcessInstance().getProcessName());

	}

	@Override
	public void beforeVariableChanged(ProcessVariableChangedEvent event) {
//		System.out.println("Before Variable Changed");
	}

}
